/* 
 * PPRacer 
 * Copyright (C) 2003-2004 The PPRacer Team
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _PP_CLASSES_H_
#define _PP_CLASSES_H_

#include "pp_types.h"
#include "ppracer.h"

class BaseItem {
public:
	ray_t ray;
	double height;
    double diam;
    int type;
};

class Item : public BaseItem {
public:
	enum Collectable{
		YES,
		NO,
		COLLECTED
	};
	
private:	
	bool drawable;
	Collectable collectable;
	int score;

public:
	inline bool isCollectable(){ return (collectable==YES); };
	inline Collectable getCollectable(){ return collectable; };
	inline void setCollectable(const Collectable state){ this->collectable=state; };

	inline bool isDrawable(){ return drawable; };
	inline void setDrawable(const bool state=true){ this->drawable=state; };

	inline int getScore(){return score;}
	inline void setScore(const int score){this->score=score;}
};

class Tree : public BaseItem {
	GLuint displayList;
public:
	inline void setDisplayList(GLuint dlist){displayList=dlist;}
	inline GLuint getDisplayList(){return displayList;}
};

#endif /* PP_CLASSES */
