/* 
 * PPRacer 
 * Copyright (C) 2003-2004 The PPRacer Team
 *
 * Copyright (C) 1999-2001 Jasmin F. Patry
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef TEXTAREA_H
#define TEXTAREA_H

#include "widget.h"
#include "button.h"
#include "ui_theme.h"

#include "fonts.h"

#include <list>

namespace pp {
	
	
class Textarea : public Widget {

	double arrow_width;
	double border_width;
	double text_pad;
	double text_region_height; /* calculated */
    double text_region_width; /* calculated */
    char *font_binding;
    pp::Color border_colour;
    pp::Color background_colour;
    pp::Button *up_button;
    pp::Button *down_button;
    char *text_orig;
    char *text_lines;
    //list_t line_list;
	std::list<char*> lines;
	std::list<char*>::iterator top_line;
	
	void calcTextRegionDims();
	void updateButtonPositions();
	void createLines();
	void updateButtonEnabledStates();
	int string_width( char *string, font_t *font );
	void drawTextLines( font_t *font );
	
public:
	Textarea( pp::Vec2d pos, pp::Vec2d size,
			     char *font_binding, char *text );
	~Textarea();

	void setText( char *text );
	void setPosition(pp::Vec2d pos);

	void upButtonClick();
	void downButtonClick();

	void draw();
};
	
} //namespace pp

#endif // TEXTAREA_H
